DBOY - Editorial

PROBLEM LINKS

Practice

Contest

DIFFICULTY

SIMPLE

PREREQUISITES

Dynamic Programming

PROBLEM

There are N fuel stations numbered 1 through N. The i-th fuel station can fill exactly Ki liters at any time. You have N days. On the i-th day, you must have exactly 2 × Hi liters in your fuel tank. After that, you will have a round trip and the tank will become empty again. Determine the minimum number of times you must fill your fuel tank on the whole N days.

QUICK EXPLANATION

Use dynamic programming approach. Let dp[i][j] = the minimum number of times to fill exactly j liters using only fuel stations 1 through i. The answer to the problem is dp[N][2 × H1] + dp[N][2 × H2] + … dp[N][2 × HN].

EXPLANATION

This is problem can be reduced to the traditional coin change problem. We have N types of coin, each having value K1, K2, …, and KN. We want to make changes for N days, each for 2 × H1, 2 × H2, …, and 2 × HN. What is the minimum number of coins needed?

Note that since each day is independent, we can minimize the number of coins on each day, and sum the results over N days.

Mathematically, for each day i, we want to minimize the value of

X1 + X2 + … + XN

subject to

X1K1 + X2K2 + … + XNKN = 2 × Hi

Xk ≥ 0 for 1 ≤ k ≤ N

We will use dynamic programming to solve this problem. Let dp[i][j] = the minimum number of coins needed to make changes for j, using only coins of types 1 through i. The base case is:

  • dp[0][0] = 0 (no coins needed)
  • dp[0][j] = infinity; for j ≠ 0 (it is impossible to make changes for j with no coins)

We can use a very large number such as 1,000,000,000 as infinity in our code.

We need to setup a recurrence relation. For each state dp[i][j], there are two possibilities:

  • We do not use any coin of type i. The minimum number of coins needed is then dp[i - 1][j].
  • We use at least one coin of type i. The minimum number of coins needed is then 1 + dp[i][j - Ki].

Therefore, we have

dp[i][j] = min(dp[i - 1][j], 1 + dp[i][j - Ki])

Both time and space complexity of this solution are in O(N × max{Hi}).

Here is a pseudocode of this solution.

read(N)
for i = 1; i ≤ N; i++:
    read(H[i])
for i = 1; i ≤ N; i++:
    read(K[i])

dp[0][0] = 0
for j = 1; j ≤ max{2 × H[i]}; j++:
    dp[0][j] = 1000000000
	
for i = 1; i ≤ N; i++:
    for j = 0; j ≤ max{2 × H[i]}; j++:
        dp[i][j] = dp[i-1][j]
        if K[i] ≤ j:
            dp[i][j] = min(dp[i][j], 1 + dp[i][j-K[i])

int res = 0
for i = 1; i ≤ N; i++:
    res = res + dp[N][2*H[i]]
println(res)

There is a solution that only uses O(max{Hi}) memory for the dp table. This solution uses the facts that:

  • dp[i][?] only refers dp[i-1][?]. So instead of keeping N rows in the DP table, we can store only the last two rows.
  • Furthermore, dp[i][x] only refers dp[i][y] for y < x. So we can store only the current row and fill the current row of the DP table from right to left.
read(N)
for i = 1; i ≤ N; i++:
    read(H[i])
for i = 1; i ≤ N; i++:
    read(K[i])

dp[0] = 0
for j = 1; j ≤ max{2 × H[i]}; j++:
    dp[j] = 1000000000
	
for i = 1; i ≤ N; i++:
    for j = K[i]; j < max{2 × H[i]}; j++:
        dp[j] = min(dp[j], 1 + dp[j-K[i])

int res = 0
for i = 1; i ≤ N; i++:
    res = res + dp[2*H[i]]
println(res)

Note that for the i-th row we fill the table from K[i] instead from 0. This is because for j &lt K[i] the DP values will not change.

Another solution is to use the so-called “forward DP”, i.e. filling the latter entries of the DP table using the values of the current entry. This is just a matter of style.

read(N)
for i = 1; i ≤ N; i++:
    read(H[i])
for i = 1; i ≤ N; i++:
    read(K[i])

dp[0] = 0
for j = 1; j ≤ max{2 × H[i]}; j++:
    dp[j] = 1000000000
	
for i = 1; i ≤ N; i++:
    for j = 0; j+K[i] < max{2 × H[i]}; j++:
        dp[j+K[i]] = min(dp[j+K[i]], 1 + dp[j])

int res = 0
for i = 1; i ≤ N; i++:
    res = res + dp[2*H[i]]
println(res)

In all solutions above, we do not remove duplicate coin types as they do not affect the answer, although they will make us recompute the same coin types in the DP table.

SETTER’S SOLUTION

Can be found here.

TESTER’S SOLUTION

Can be found here.

21 Likes

The O(max{H}) space approach is actually min-coin change problem.

4 Likes

Hello coders,

I tried similar approach, but my code got TLE.

Any idea what’s wrong?

Hi

I have tried a similar approach but I am getting WA. Please help me find out the error. Code is here

I had figured out that it is identical to coin change problem. I had used the below approach.

  1. First find max{H} = H_max;
  2. Allocate an integer array dp, of size (H_max*2+1)
  3. Initialize dp[i] = i for all i;
  4. Apply DP using recursive relation
    for(int i=1; i<=size{H}; i++) {
        for(int j=1; j<=size{K}; j++) {
            if(K[j] == i) {
                opt[i] = 1;
                break;
            } else if(K[j] < i) {
                if((opt[i - K[j]] + 1) < opt[i]) {
                    opt[i] = (opt[i - K[j]] + 1);
                }
            }
        }
    }

The space complexity is O(H_max*2) and time complexity is O(size{K} * size{H})

I was getting WA. It is pretty much on the same line as “forward DP” mentioned above. Tried with many variant of this, but couldn’t get it through. Surely would have missed some corner case. Would be great if anybody can point out the mistake in the logic

I tried solving this using recursion and wonder if anyone can spot what I am doing wrong in my code?

Code is here

Can someone please tell me the recurrence tree of this problem.Thanks in advance.

1 Like

#include 
#include 
#include 
#include 
	
using namespace std;

int main() {
	int t;
	scanf("%d",&t);
	int H[501],K[501];

	
	int N,max;
	while(t--)
	{
		int dp[501][1001];
		max=0;
		scanf("%d",&N);
		for(int i=1;i<=N;i++)
		{
		scanf("%d",&H[i]);
		if(max<H[i])
		max=H[i];
		}
		for(int i=1;i<=N;i++)
		scanf("%d",&K[i]);
		dp[0][0]=0;
		for(int j=1;j<=max*2;j++)
		dp[0][j]=1000000000;
		
		for(int i=1;i<=N;i++)
		{
			for(int j=0;j<=2*max;j++)
			{
				dp[i][j]=dp[i-1][j];
				if(K[i]<=j)
				dp[i][j]=min(dp[i][j],1+dp[i][j-K[i]]);
			}
		}
		int sum=0;
		for(int i=1;i<=N;i++){
			sum=sum+dp[N][2*H[i]];
		}
		printf("%d",sum);
		
	}
	
	// your code goes here
	return 0;
}

```

why my answer is giving WA pls help

The approach I have taken is like this.

Let M[1…1001] be an array , where M[i] denotes the minimum number of refills needed to cover a distance i.

From this we get the recurrence M[i] = min(k = 0 to (i/2)){ M[k] + M[i - k] }

Using a bottom up approach, we can build a solution.

Initially M[i] = inf for all i

IF i is an element of K[i], M[i] = 1

After this we can do the bottom up approach as follows:


for(i = 1 ; i <= 1000 ; i++)
{
   for(j = 0 ; j <= (i / 2) ; j++)
   {
	if(M[i] > (M[j] + M[i - j]))
		M[i] = M[j] + M[i - j];
   }
}

Finally summing just the distances we need:

sum = 0;
for(i = 0 ; i < n ; i++)
sum += M[2 * h[i]];
printf("%d\n" , sum);


Hope this helps :) 

Link to my solution:http://www.codechef.com/viewsolution/5265891
1 Like

I know its a very old question but I was trying it as a practice and noticed a strange thing:
Going by the for loops as in the solution setting give AC. But interchanging the order of for loops gives wrong answer. Any one who can throw some more light?
@betista’s solution and @prakash1529’s comment also highlights the same phenomenon. Any pointers to this mistery?

can anyone tell me what’s wrong with my code? here’s my code CodeChef: Practical coding for everyone

why my answer is TLE where i use O(n*n) solution
here is my solution

Getting WA, help me to find the error
code: ymxAP0 - Online C++ Compiler & Debugging Tool - Ideone.com

for those who are getting wrong answer by solving like coin change problem and getting AC after interchanging the loop. You are getting wrong answer because you are not checking the overflow condition while updating table[i].i.e. in statement (table[i]=1+table[i-k[j]]), table[i-k[j]] can be INT_MAX and hence 1+table[i-k[j]] can cause overflow. Here is the correct code. It shows AC.

Hope this help.

8 Likes

Hmmm… Surprisingly, just interchanging for loops as given in the solution section is getting AC. How does it makes a difference whether we iterate over {K}-> {H} or {H}-> {K}. Interesting and frustrating!!!

1 Like

I think in your code, there is an extra factor in the complexity.
This is due to the fact that a coin can be used more than once.
So, your worst case complexity is- O(N × max{Hi} × max{Hi}).

@prakash1529 Maybe taking into account cache misses in the target system , your observation makes sense :slight_smile:

What’s wrong with this strategy?
I have used a greedy strategy, such that it selects the biggest Ki such that Ki < H[i]*2, and then subtract that value from H[i]*2 and then apply the same procedure on this new value until H[i]*2 becomes 0.
I have used STL set data structure for this so the complexity is NlogN but I’m getting WA (not TLE).

#include
#include
#include

using namespace std;

int main()
{
int T;
cin >> T;

while (T--)
{
	int N;
	cin >> N;

	vector<int> H(N);
	for (size_t i = 0; i < H.size(); ++i)
		cin >> H[i];

	set<int, greater<int>> K;
	for (int i = 0, k; i < N; ++i)
	{
		cin >> k;
		K.insert(k);
	}

	int ans = 0;
	for (size_t i = 0; i < H.size(); ++i)
	{
		int h = H[i] * 2;
		while (h)
		{
			int temp = *K.lower_bound(h);
			//cout << temp << endl;
			h -= temp;
			++ans;
		}
		//cout << endl;
	}

	cout << ans << endl;
}

}

Greedy strategy will not work in the following case
K: 3 4 5
H:3 4 5

Correct answer: Going to K[0] twice
Greedy strategy will not give any answer, since your answer would be actually 5(which is K[2])+1(which is not present)

I guess the statement that at least one answer exists is a bit confusing

As per the previous questions asked about whether we can use recursion or not, I am here to answer that…
And the answer is a big NO…
eg: consider h[]={10 , 11 } and k[]={4,5}
if we trace the recursion across the twice of maximum i.e., 2*11=22, then we get the tree as:-
Capture
we never get minimum for 2x10=20 unlike bottom up approach